Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 60395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 60419)
@@ -40,12 +40,12 @@
 
 /*********************************************************************************************************************************
-*   Class UIApplianceCertificateViewer.                                                                                          *
+*   Class UIApplianceUnverifiedCertificateViewer implementation.                                                                 *
 *********************************************************************************************************************************/
 
-UIApplianceUnverifiedCertificate::UIApplianceUnverifiedCertificate(QWidget *pParent, const CCertificate &certificate)
+UIApplianceUnverifiedCertificateViewer::UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &certificate)
     : QIWithRetranslateUI<QIDialog>(pParent)
     , m_certificate(certificate)
-    , m_pTextLabel(NULL)
-    , m_pTextBrowser(NULL)
+    , m_pTextLabel(0)
+    , m_pTextBrowser(0)
 {
     /* Prepare: */
@@ -53,5 +53,5 @@
 }
 
-void UIApplianceUnverifiedCertificate::prepare()
+void UIApplianceUnverifiedCertificateViewer::prepare()
 {
     /* Create layout: */
@@ -85,11 +85,8 @@
             /* Configure button-box: */
             pButtonBox->setStandardButtons(QDialogButtonBox::Yes | QDialogButtonBox::No);
-
             pButtonBox->button(QDialogButtonBox::Yes)->setShortcut(Qt::Key_Enter);
+            //pButtonBox->button(QDialogButtonBox::No)->setShortcut(Qt::Key_Esc);
             connect(pButtonBox, SIGNAL(accepted()), this, SLOT(accept()));
-
-            //pButtonBox->button(QDialogButtonBox::No)->setShortcut(Qt::Key_Esc);
             connect(pButtonBox, SIGNAL(rejected()), this, SLOT(reject()));
-
             /* Add button-box into layout: */
             pLayout->addWidget(pButtonBox);
@@ -100,5 +97,5 @@
 }
 
-void UIApplianceUnverifiedCertificate::retranslateUi()
+void UIApplianceUnverifiedCertificateViewer::retranslateUi()
 {
     /* Translate dialog title: */
@@ -223,7 +220,5 @@
         m_strSignedBy = certificate.GetFriendlyName();
 
-        /*
-         * If trusted, just select the right message.
-         */
+        /* If trusted, just select the right message: */
         if (certificate.GetTrusted())
         {
@@ -235,12 +230,12 @@
         else
         {
-            /*
-             * Not trusted!  Must ask the user whether to continue in this case.
-             */
+            /* Not trusted!  Must ask the user whether to continue in this case: */
             m_enmCertText = !certificate.GetExpired() ? kCertText_SelfSignedUnverified : kCertText_SelfSignedUnverified;
+
+            /* Translate page early: */
             retranslateUi();
 
             /* Instantiate the dialog: */
-            QPointer<UIApplianceUnverifiedCertificate> pDialog = new UIApplianceUnverifiedCertificate(this, certificate);
+            QPointer<UIApplianceUnverifiedCertificateViewer> pDialog = new UIApplianceUnverifiedCertificateViewer(this, certificate);
             AssertPtrReturnVoid(pDialog.data());
 
@@ -250,10 +245,10 @@
             /* Leave if destroyed prematurely: */
             if (!pDialog)
-                return; /** @todo r=bird: what happened to this dialog in that case??, will check this case later. */
+                return;
             /* Delete viewer: */
             if (pDialog)
             {
                 delete pDialog;
-                pDialog = NULL;
+                pDialog = 0;
             }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 60395)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.h	(revision 60419)
@@ -82,16 +82,17 @@
 };
 
-/**
- * Dialog for asking consent to continue with unverifiable certificate.
- */
-class UIApplianceUnverifiedCertificate : public QIWithRetranslateUI<QIDialog>
+/** QIDialog extension
+  * asking for consent to continue with unverifiable certificate. */
+class UIApplianceUnverifiedCertificateViewer : public QIWithRetranslateUI<QIDialog>
 {
     Q_OBJECT;
 
 public:
+
     /** Constructs appliance @a certificate viewer for passed @a pParent. */
-    UIApplianceUnverifiedCertificate(QWidget *pParent, const CCertificate &certificate);
+    UIApplianceUnverifiedCertificateViewer(QWidget *pParent, const CCertificate &certificate);
 
 protected:
+
     /** Prepares all. */
     void prepare();
@@ -101,4 +102,5 @@
 
 private:
+
     /** Holds the certificate reference. */
     const CCertificate &m_certificate;